/*	*	*	*	*	*	*	*	*	*/
/*	at.c	produce AutoCAD script file from coded text		*/
/*									*/
/*	11-16-85	cfg	begin					*/
/*	11-17-85	cfg	add switch				*/
/*	*	*	*	*	*	*	*	*	*/
#include <stdio.h>
#include <ath.h>

/*
#define TESTING	0
*/

#define NUMARGS		3

#define ATEXT		1
#include <atex.h>

main(argc,argv)
int argc;
char *argv[];
{
	char type[2];

	angle[0]=height[0]='\0';

	setbase("0,0");	

	fprintf(stderr,"\natext Version 1.1 by Charles Grammer\n");

	if (usage(argc,NUMARGS,"atext inputfile outputfile") != 0) exit(-1);
	if (( fdr=fopen(INPUT_FILE, "r")) == NULL)
		{
		fprintf(stderr,"atext: Can't open %s for reading.\n",
			INPUT_FILE);
		exit(-1);
		}
	if (( fdw=fopen(OUTPUT_FILE, "w")) == NULL)
		{
		fprintf(stderr,"atext: Can't open %s for reading.\n",
			OUTPUT_FILE);
		exit(-1);
		}

#ifdef TESTING
printf("opened files %s for reading and %s for writing\n",
	INPUT_FILE,OUTPUT_FILE);
#endif

/*
 * main loop of program
 */
/*
 * get line from input file
 */
	while ( fgets(buffer,sizeof buffer, fdr) != (char *)NULL )
	     {
#ifdef TESTING
printf("****\tinput string: >%s<\n",buffer);
#endif
/*
 * test for command
 */
	     if (strncmp(buffer, ".", 1) == SAME)
		{
#ifdef TESTING
printf("found command\n");
#endif
/*
 * if it is a . command, read next character as command
 */
		sscanf(buffer, ".%2s", type);
#ifdef TESTING
printf("type = d>%d %d< = s>%s<\n",type[0],type[1],type);
#endif
		if (select(INPUT_FILE) == FALSE)
			atfinit(INPUT_FILE,OUTPUT_FILE);
		} /* end if (command) */
/*
 * if line is blank (CR only), do nothing
 */
	     else if (buffer[0] == 10)
		{
#ifdef TESTING
printf("found carriage return\n");
#endif
		}
/*
 * found something else; dependent line of text or bogus
 */
	     else
		{
#ifdef TESTING
printf("found something else\n");
printf("first character of line (decimal): >%d<\n",buffer[0]);
#endif
		     atse();
		}
#ifdef TESTING
printf("end of command loop\n");
#endif
	     } /* end while reading file */
#ifdef TESTING
printf("done\n");
#endif
/*
 * write script commands for final exit from drawing editor
 * clean up and go home
 */
	atendfil();
	atfinit(INPUT_FILE,OUTPUT_FILE);
} /* end main */

/*	*	*	*	*	*	*	*	*	*/
/*	atfinit():	close files, message about processing		*/
#undef ATEXT
#include <atex.h>

atfinit(infile,outfile)
char *infile[],*outfile[];
{
	fprintf (stderr, "\n\nProcessed %d commands and lines from %s to %s\n",
		record,infile,outfile);
	close(fdw);
	close(fdlw);
	close(fdr);
	exit(0);
} /* end atfinit()	*/